/*
	Alternate plugin for AviSynth

	Copyright (C) 2006 Mohan
  
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation.
	 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
		
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	The author can be contacted at the doom9.org forum under mg262.
*/

#include "stdafx.h"

class Alternate : public GenericVideoFilter 
{   
	PClip other;
	int duration;
public:
	Alternate(PClip _child, PClip _other, int _duration, IScriptEnvironment *env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
};

Alternate::Alternate(PClip _child, PClip _other, int _duration, IScriptEnvironment *env) : 
	GenericVideoFilter(_child), other(_other), duration(_duration)
{
//	vi.
}

PVideoFrame __stdcall Alternate::GetFrame(int n, IScriptEnvironment *env) 
{
	if(  (n%(2*duration)) < duration)
		return child->GetFrame(n, env);
	else
		return other->GetFrame(n, env);
}



AVSValue __cdecl Create_Alternate(AVSValue args, void *user_data, IScriptEnvironment *env) 
{
	return new Alternate(args[0].AsClip(), args[1].AsClip(), args[2].AsInt(25), env);  
}

extern "C" __declspec(dllexport) const char *__stdcall AvisynthPluginInit2(IScriptEnvironment *env) 
{
	env->AddFunction("Alternate", "cc[duration]i", Create_Alternate, 0);
	return "Alternate plugin";
}
